unit httpsservmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, http, stSecUtils, StreamSec.Mobile.SecComp,
  StreamSec.Mobile.StreamSecII, StreamSec.Mobile.TlsInternalServer,
  StreamSec.Mobile.TlsClass, StreamSec.Mobile.X509Comp, SelectCipherSuitesFrame,
  Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    smSimpleTLSInternalServer1: TsmSimpleTLSInternalServer;
    TfrmSelectCipherSuites1: TfrmSelectCipherSuites;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SimpleTLSInternalServer1TLSIncomingAlert(Sender: TObject;
      Client: TCustomTLS_ContentLayer; var Fatal: Boolean; AlertCode: Integer);
    procedure SimpleTLSInternalServer1TLSOutgoingAlert(Sender: TObject;
      Client: TCustomTLS_ContentLayer; var Fatal: Boolean; AlertCode: Integer);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  stGC;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  smSimpleTLSInternalServer1.ImportFromPFX('Server.pfx',TSecretKey.CreateBMPStr('abc',3));
  smSimpleTLSInternalServer1.Options.KeyAgreementRSA := prAllowed;
  smSimpleTLSInternalServer1.Options.KeyAgreementECDHE := prPrefer;
  smSimpleTLSInternalServer1.Options.BulkCipherAES128 := prAllowed;
  smSimpleTLSInternalServer1.Options.BulkCipherTripleDES := prNotAllowed;
  smSimpleTLSInternalServer1.Options.BulkCipherAES192 := prNotAllowed;
  smSimpleTLSInternalServer1.Options.BulkCipherAES256 := prNotAllowed;
  smSimpleTLSInternalServer1.TLSSetupServer;
  TfrmSelectCipherSuites1.Options := smSimpleTLSInternalServer1.Options;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ShowMessage(smSimpleTLSInternalServer1.Options.CipherSuiteNames.Text);
  TTCPHttpDaemon.create;
end;

procedure TForm1.SimpleTLSInternalServer1TLSIncomingAlert(Sender: TObject;
  Client: TCustomTLS_ContentLayer; var Fatal: Boolean; AlertCode: Integer);
begin
  // Log
end;

procedure TForm1.SimpleTLSInternalServer1TLSOutgoingAlert(Sender: TObject;
  Client: TCustomTLS_ContentLayer; var Fatal: Boolean; AlertCode: Integer);
begin
  // Log
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  stGC.tGCManager.GetDefault.Sweep;
end;

end.
